<?php

namespace App\Policies;

use App\Models\JoinTeamSubmission;
use App\Models\User;
use Illuminate\Auth\Access\Response;

class JoinTeamSubmissionPolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        return $user->hasAnyPermission([
            'create jointeamsubmission', 'edit jointeamsubmission', 'view jointeamsubmission', 'delete jointeamsubmission'
        ]);
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, JoinTeamSubmission $joinTeamSubmission): bool
    {
        return $user->hasPermissionTo('view jointeamsubmission');
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return $user->hasPermissionTo('create jointeamsubmission');
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, JoinTeamSubmission $joinTeamSubmission): bool
    {
        return $user->hasPermissionTo('edit jointeamsubmission');
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, JoinTeamSubmission $joinTeamSubmission): bool
    {
        return $user->hasPermissionTo('delete jointeamsubmission');
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, JoinTeamSubmission $joinTeamSubmission): bool
    {
        return $user->hasPermissionTo('restore jointeamsubmission');
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, JoinTeamSubmission $joinTeamSubmission): bool
    {
        return $user->hasPermissionTo('force delete jointeamsubmission');
    }
}
